using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace MockSubSonic.DAL
{
	/// <summary>
	/// Strongly-typed collection for the RssChannel class.
	/// </summary>
	[Serializable]
	public partial class RssChannelCollection : ActiveList<RssChannel, RssChannelCollection> 
	{	   
		public RssChannelCollection() {}

	}

	/// <summary>
	/// This is an ActiveRecord class which wraps the RssChannel table.
	/// </summary>
	[Serializable]
	public partial class RssChannel : ActiveRecord<RssChannel>
	{
		#region .ctors and Default Settings
		
		public RssChannel()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}

		
		private void InitSetDefaults() { SetDefaults(); }

		
		public RssChannel(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}

		public RssChannel(object keyID)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByKey(keyID);
		}

		 
		public RssChannel(string columnName, object columnValue)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByParam(columnName,columnValue);
		}

		
		protected static void SetSQLProps() { GetTableSchema(); }

		
		#endregion
		
		#region Schema and Query Accessor
		public static Query CreateQuery() { return new Query(Schema); }

		
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}

		}

		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("RssChannel", TableType.Table, DataService.GetInstance("HowToUnitTest"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"dbo";
				//columns
				
				TableSchema.TableColumn colvarId = new TableSchema.TableColumn(schema);
				colvarId.ColumnName = "id";
				colvarId.DataType = DbType.Int32;
				colvarId.MaxLength = 0;
				colvarId.AutoIncrement = true;
				colvarId.IsNullable = false;
				colvarId.IsPrimaryKey = true;
				colvarId.IsForeignKey = false;
				colvarId.IsReadOnly = false;
				colvarId.DefaultSetting = @"";
				colvarId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarId);
				
				TableSchema.TableColumn colvarTitle = new TableSchema.TableColumn(schema);
				colvarTitle.ColumnName = "Title";
				colvarTitle.DataType = DbType.String;
				colvarTitle.MaxLength = 1000;
				colvarTitle.AutoIncrement = false;
				colvarTitle.IsNullable = false;
				colvarTitle.IsPrimaryKey = false;
				colvarTitle.IsForeignKey = false;
				colvarTitle.IsReadOnly = false;
				colvarTitle.DefaultSetting = @"";
				colvarTitle.ForeignKeyTableName = "";
				schema.Columns.Add(colvarTitle);
				
				TableSchema.TableColumn colvarPubDate = new TableSchema.TableColumn(schema);
				colvarPubDate.ColumnName = "PubDate";
				colvarPubDate.DataType = DbType.DateTime;
				colvarPubDate.MaxLength = 0;
				colvarPubDate.AutoIncrement = false;
				colvarPubDate.IsNullable = false;
				colvarPubDate.IsPrimaryKey = false;
				colvarPubDate.IsForeignKey = false;
				colvarPubDate.IsReadOnly = false;
				colvarPubDate.DefaultSetting = @"";
				colvarPubDate.ForeignKeyTableName = "";
				schema.Columns.Add(colvarPubDate);
				
				TableSchema.TableColumn colvarDescription = new TableSchema.TableColumn(schema);
				colvarDescription.ColumnName = "Description";
				colvarDescription.DataType = DbType.String;
				colvarDescription.MaxLength = -1;
				colvarDescription.AutoIncrement = false;
				colvarDescription.IsNullable = true;
				colvarDescription.IsPrimaryKey = false;
				colvarDescription.IsForeignKey = false;
				colvarDescription.IsReadOnly = false;
				colvarDescription.DefaultSetting = @"";
				colvarDescription.ForeignKeyTableName = "";
				schema.Columns.Add(colvarDescription);
				
				TableSchema.TableColumn colvarUri = new TableSchema.TableColumn(schema);
				colvarUri.ColumnName = "Uri";
				colvarUri.DataType = DbType.String;
				colvarUri.MaxLength = 1000;
				colvarUri.AutoIncrement = false;
				colvarUri.IsNullable = false;
				colvarUri.IsPrimaryKey = false;
				colvarUri.IsForeignKey = false;
				colvarUri.IsReadOnly = false;
				colvarUri.DefaultSetting = @"";
				colvarUri.ForeignKeyTableName = "";
				schema.Columns.Add(colvarUri);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["HowToUnitTest"].AddSchema("RssChannel",schema);
			}

		}

		#endregion
		
		#region Props
		
		  
		[XmlAttribute("Id")]
		public int Id 
		{
			get { return GetColumnValue<int>("id"); }

			set { SetColumnValue("id", value); }

		}

		  
		[XmlAttribute("Title")]
		public string Title 
		{
			get { return GetColumnValue<string>("Title"); }

			set { SetColumnValue("Title", value); }

		}

		  
		[XmlAttribute("PubDate")]
		public DateTime PubDate 
		{
			get { return GetColumnValue<DateTime>("PubDate"); }

			set { SetColumnValue("PubDate", value); }

		}

		  
		[XmlAttribute("Description")]
		public string Description 
		{
			get { return GetColumnValue<string>("Description"); }

			set { SetColumnValue("Description", value); }

		}

		  
		[XmlAttribute("Uri")]
		public string Uri 
		{
			get { return GetColumnValue<string>("Uri"); }

			set { SetColumnValue("Uri", value); }

		}

		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
		#region ObjectDataSource support
		
		
		/// <summary>
		/// Inserts a record, can be used with the Object Data Source
		/// </summary>
		public static void Insert(string varTitle,DateTime varPubDate,string varDescription,string varUri)
		{
			RssChannel item = new RssChannel();
			
			item.Title = varTitle;
			
			item.PubDate = varPubDate;
			
			item.Description = varDescription;
			
			item.Uri = varUri;
			
		
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}

		
		/// <summary>
		/// Updates a record, can be used with the Object Data Source
		/// </summary>
		public static void Update(int varId,string varTitle,DateTime varPubDate,string varDescription,string varUri)
		{
			RssChannel item = new RssChannel();
			
				item.Id = varId;
				
				item.Title = varTitle;
				
				item.PubDate = varPubDate;
				
				item.Description = varDescription;
				
				item.Uri = varUri;
				
			item.IsNew = false;
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}

		#endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string Id = @"id";
			 public static string Title = @"Title";
			 public static string PubDate = @"PubDate";
			 public static string Description = @"Description";
			 public static string Uri = @"Uri";
						
		}

		#endregion
	}

}

