using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace MockSubSonic.DAL
{
    /// <summary>
    /// Controller class for RssChannel
    /// </summary>
    [System.ComponentModel.DataObject]
    public partial class RssChannelController
    {
        // Preload our schema..
        RssChannel thisSchemaLoad = new RssChannel();
        private string userName = string.Empty;
        protected string UserName
        {
            get
            {
				if (userName.Length == 0) 
				{
    				if (System.Web.HttpContext.Current != null)
    				{
						userName=System.Web.HttpContext.Current.User.Identity.Name;
					}

					else
					{
						userName=System.Threading.Thread.CurrentPrincipal.Identity.Name;
					}

				}

				return userName;
            }

        }

        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public RssChannelCollection FetchAll()
        {
            RssChannelCollection coll = new RssChannelCollection();
            Query qry = new Query(RssChannel.Schema);
            coll.LoadAndCloseReader(qry.ExecuteReader());
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Select, false)]
        public RssChannelCollection FetchByID(object Id)
        {
            RssChannelCollection coll = new RssChannelCollection().Where("id", Id).Load();
            return coll;
        }

		
		[DataObjectMethod(DataObjectMethodType.Select, false)]
        public RssChannelCollection FetchByQuery(Query qry)
        {
            RssChannelCollection coll = new RssChannelCollection();
            coll.LoadAndCloseReader(qry.ExecuteReader()); 
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public bool Delete(object Id)
        {
            return (RssChannel.Delete(Id) == 1);
        }

        [DataObjectMethod(DataObjectMethodType.Delete, false)]
        public bool Destroy(object Id)
        {
            return (RssChannel.Destroy(Id) == 1);
        }

        
        
    	
	    /// <summary>
	    /// Inserts a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Insert, true)]
	    public void Insert(string Title,DateTime PubDate,string Description,string Uri)
	    {
		    RssChannel item = new RssChannel();
		    
            item.Title = Title;
            
            item.PubDate = PubDate;
            
            item.Description = Description;
            
            item.Uri = Uri;
            
	    
		    item.Save(UserName);
	    }

    	
	    /// <summary>
	    /// Updates a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Update, true)]
	    public void Update(int Id,string Title,DateTime PubDate,string Description,string Uri)
	    {
		    RssChannel item = new RssChannel();
		    
				item.Id = Id;
				
				item.Title = Title;
				
				item.PubDate = PubDate;
				
				item.Description = Description;
				
				item.Uri = Uri;
				
		    item.MarkOld();
		    item.Save(UserName);
	    }

    }

}

