using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace MockSubSonic.DAL
{
	/// <summary>
	/// Strongly-typed collection for the RssItem class.
	/// </summary>
	[Serializable]
	public partial class RssItemCollection : ActiveList<RssItem, RssItemCollection> 
	{	   
		public RssItemCollection() {}

	}

	/// <summary>
	/// This is an ActiveRecord class which wraps the RssItem table.
	/// </summary>
	[Serializable]
	public partial class RssItem : ActiveRecord<RssItem>
	{
		#region .ctors and Default Settings
		
		public RssItem()
		{
		  SetSQLProps();
		  InitSetDefaults();
		  MarkNew();
		}

		
		private void InitSetDefaults() { SetDefaults(); }

		
		public RssItem(bool useDatabaseDefaults)
		{
			SetSQLProps();
			if(useDatabaseDefaults)
				ForceDefaults();
			MarkNew();
		}

		public RssItem(object keyID)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByKey(keyID);
		}

		 
		public RssItem(string columnName, object columnValue)
		{
			SetSQLProps();
			InitSetDefaults();
			LoadByParam(columnName,columnValue);
		}

		
		protected static void SetSQLProps() { GetTableSchema(); }

		
		#endregion
		
		#region Schema and Query Accessor
		public static Query CreateQuery() { return new Query(Schema); }

		
		public static TableSchema.Table Schema
		{
			get
			{
				if (BaseSchema == null)
					SetSQLProps();
				return BaseSchema;
			}

		}

		
		private static void GetTableSchema() 
		{
			if(!IsSchemaInitialized)
			{
				//Schema declaration
				TableSchema.Table schema = new TableSchema.Table("RssItem", TableType.Table, DataService.GetInstance("HowToUnitTest"));
				schema.Columns = new TableSchema.TableColumnCollection();
				schema.SchemaName = @"dbo";
				//columns
				
				TableSchema.TableColumn colvarId = new TableSchema.TableColumn(schema);
				colvarId.ColumnName = "id";
				colvarId.DataType = DbType.Int32;
				colvarId.MaxLength = 0;
				colvarId.AutoIncrement = true;
				colvarId.IsNullable = false;
				colvarId.IsPrimaryKey = true;
				colvarId.IsForeignKey = false;
				colvarId.IsReadOnly = false;
				colvarId.DefaultSetting = @"";
				colvarId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarId);
				
				TableSchema.TableColumn colvarChannelId = new TableSchema.TableColumn(schema);
				colvarChannelId.ColumnName = "channelId";
				colvarChannelId.DataType = DbType.Int32;
				colvarChannelId.MaxLength = 0;
				colvarChannelId.AutoIncrement = false;
				colvarChannelId.IsNullable = false;
				colvarChannelId.IsPrimaryKey = false;
				colvarChannelId.IsForeignKey = false;
				colvarChannelId.IsReadOnly = false;
				colvarChannelId.DefaultSetting = @"";
				colvarChannelId.ForeignKeyTableName = "";
				schema.Columns.Add(colvarChannelId);
				
				TableSchema.TableColumn colvarTitle = new TableSchema.TableColumn(schema);
				colvarTitle.ColumnName = "Title";
				colvarTitle.DataType = DbType.String;
				colvarTitle.MaxLength = 1000;
				colvarTitle.AutoIncrement = false;
				colvarTitle.IsNullable = false;
				colvarTitle.IsPrimaryKey = false;
				colvarTitle.IsForeignKey = false;
				colvarTitle.IsReadOnly = false;
				colvarTitle.DefaultSetting = @"";
				colvarTitle.ForeignKeyTableName = "";
				schema.Columns.Add(colvarTitle);
				
				TableSchema.TableColumn colvarPubDate = new TableSchema.TableColumn(schema);
				colvarPubDate.ColumnName = "PubDate";
				colvarPubDate.DataType = DbType.DateTime;
				colvarPubDate.MaxLength = 0;
				colvarPubDate.AutoIncrement = false;
				colvarPubDate.IsNullable = false;
				colvarPubDate.IsPrimaryKey = false;
				colvarPubDate.IsForeignKey = false;
				colvarPubDate.IsReadOnly = false;
				colvarPubDate.DefaultSetting = @"";
				colvarPubDate.ForeignKeyTableName = "";
				schema.Columns.Add(colvarPubDate);
				
				TableSchema.TableColumn colvarLink = new TableSchema.TableColumn(schema);
				colvarLink.ColumnName = "Link";
				colvarLink.DataType = DbType.String;
				colvarLink.MaxLength = 1000;
				colvarLink.AutoIncrement = false;
				colvarLink.IsNullable = false;
				colvarLink.IsPrimaryKey = false;
				colvarLink.IsForeignKey = false;
				colvarLink.IsReadOnly = false;
				colvarLink.DefaultSetting = @"";
				colvarLink.ForeignKeyTableName = "";
				schema.Columns.Add(colvarLink);
				
				TableSchema.TableColumn colvarDescription = new TableSchema.TableColumn(schema);
				colvarDescription.ColumnName = "Description";
				colvarDescription.DataType = DbType.String;
				colvarDescription.MaxLength = -1;
				colvarDescription.AutoIncrement = false;
				colvarDescription.IsNullable = false;
				colvarDescription.IsPrimaryKey = false;
				colvarDescription.IsForeignKey = false;
				colvarDescription.IsReadOnly = false;
				colvarDescription.DefaultSetting = @"";
				colvarDescription.ForeignKeyTableName = "";
				schema.Columns.Add(colvarDescription);
				
				TableSchema.TableColumn colvarAuthor = new TableSchema.TableColumn(schema);
				colvarAuthor.ColumnName = "Author";
				colvarAuthor.DataType = DbType.String;
				colvarAuthor.MaxLength = 250;
				colvarAuthor.AutoIncrement = false;
				colvarAuthor.IsNullable = false;
				colvarAuthor.IsPrimaryKey = false;
				colvarAuthor.IsForeignKey = false;
				colvarAuthor.IsReadOnly = false;
				colvarAuthor.DefaultSetting = @"";
				colvarAuthor.ForeignKeyTableName = "";
				schema.Columns.Add(colvarAuthor);
				
				BaseSchema = schema;
				//add this schema to the provider
				//so we can query it later
				DataService.Providers["HowToUnitTest"].AddSchema("RssItem",schema);
			}

		}

		#endregion
		
		#region Props
		
		  
		[XmlAttribute("Id")]
		public int Id 
		{
			get { return GetColumnValue<int>("id"); }

			set { SetColumnValue("id", value); }

		}

		  
		[XmlAttribute("ChannelId")]
		public int ChannelId 
		{
			get { return GetColumnValue<int>("channelId"); }

			set { SetColumnValue("channelId", value); }

		}

		  
		[XmlAttribute("Title")]
		public string Title 
		{
			get { return GetColumnValue<string>("Title"); }

			set { SetColumnValue("Title", value); }

		}

		  
		[XmlAttribute("PubDate")]
		public DateTime PubDate 
		{
			get { return GetColumnValue<DateTime>("PubDate"); }

			set { SetColumnValue("PubDate", value); }

		}

		  
		[XmlAttribute("Link")]
		public string Link 
		{
			get { return GetColumnValue<string>("Link"); }

			set { SetColumnValue("Link", value); }

		}

		  
		[XmlAttribute("Description")]
		public string Description 
		{
			get { return GetColumnValue<string>("Description"); }

			set { SetColumnValue("Description", value); }

		}

		  
		[XmlAttribute("Author")]
		public string Author 
		{
			get { return GetColumnValue<string>("Author"); }

			set { SetColumnValue("Author", value); }

		}

		
		#endregion
		
		
			
		
		//no foreign key tables defined (0)
		
		
		
		//no ManyToMany tables defined (0)
		
		#region ObjectDataSource support
		
		
		/// <summary>
		/// Inserts a record, can be used with the Object Data Source
		/// </summary>
		public static void Insert(int varChannelId,string varTitle,DateTime varPubDate,string varLink,string varDescription,string varAuthor)
		{
			RssItem item = new RssItem();
			
			item.ChannelId = varChannelId;
			
			item.Title = varTitle;
			
			item.PubDate = varPubDate;
			
			item.Link = varLink;
			
			item.Description = varDescription;
			
			item.Author = varAuthor;
			
		
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}

		
		/// <summary>
		/// Updates a record, can be used with the Object Data Source
		/// </summary>
		public static void Update(int varId,int varChannelId,string varTitle,DateTime varPubDate,string varLink,string varDescription,string varAuthor)
		{
			RssItem item = new RssItem();
			
				item.Id = varId;
				
				item.ChannelId = varChannelId;
				
				item.Title = varTitle;
				
				item.PubDate = varPubDate;
				
				item.Link = varLink;
				
				item.Description = varDescription;
				
				item.Author = varAuthor;
				
			item.IsNew = false;
			if (System.Web.HttpContext.Current != null)
				item.Save(System.Web.HttpContext.Current.User.Identity.Name);
			else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name);
		}

		#endregion
		#region Columns Struct
		public struct Columns
		{
			 public static string Id = @"id";
			 public static string ChannelId = @"channelId";
			 public static string Title = @"Title";
			 public static string PubDate = @"PubDate";
			 public static string Link = @"Link";
			 public static string Description = @"Description";
			 public static string Author = @"Author";
						
		}

		#endregion
	}

}

