using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace MockSubSonic.DAL
{
    /// <summary>
    /// Controller class for RssItem
    /// </summary>
    [System.ComponentModel.DataObject]
    public partial class RssItemController
    {
        // Preload our schema..
        RssItem thisSchemaLoad = new RssItem();
        private string userName = string.Empty;
        protected string UserName
        {
            get
            {
				if (userName.Length == 0) 
				{
    				if (System.Web.HttpContext.Current != null)
    				{
						userName=System.Web.HttpContext.Current.User.Identity.Name;
					}

					else
					{
						userName=System.Threading.Thread.CurrentPrincipal.Identity.Name;
					}

				}

				return userName;
            }

        }

        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public RssItemCollection FetchAll()
        {
            RssItemCollection coll = new RssItemCollection();
            Query qry = new Query(RssItem.Schema);
            coll.LoadAndCloseReader(qry.ExecuteReader());
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Select, false)]
        public RssItemCollection FetchByID(object Id)
        {
            RssItemCollection coll = new RssItemCollection().Where("id", Id).Load();
            return coll;
        }

		
		[DataObjectMethod(DataObjectMethodType.Select, false)]
        public RssItemCollection FetchByQuery(Query qry)
        {
            RssItemCollection coll = new RssItemCollection();
            coll.LoadAndCloseReader(qry.ExecuteReader()); 
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public bool Delete(object Id)
        {
            return (RssItem.Delete(Id) == 1);
        }

        [DataObjectMethod(DataObjectMethodType.Delete, false)]
        public bool Destroy(object Id)
        {
            return (RssItem.Destroy(Id) == 1);
        }

        
        
    	
	    /// <summary>
	    /// Inserts a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Insert, true)]
	    public void Insert(int ChannelId,string Title,DateTime PubDate,string Link,string Description,string Author)
	    {
		    RssItem item = new RssItem();
		    
            item.ChannelId = ChannelId;
            
            item.Title = Title;
            
            item.PubDate = PubDate;
            
            item.Link = Link;
            
            item.Description = Description;
            
            item.Author = Author;
            
	    
		    item.Save(UserName);
	    }

    	
	    /// <summary>
	    /// Updates a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Update, true)]
	    public void Update(int Id,int ChannelId,string Title,DateTime PubDate,string Link,string Description,string Author)
	    {
		    RssItem item = new RssItem();
		    
				item.Id = Id;
				
				item.ChannelId = ChannelId;
				
				item.Title = Title;
				
				item.PubDate = PubDate;
				
				item.Link = Link;
				
				item.Description = Description;
				
				item.Author = Author;
				
		    item.MarkOld();
		    item.Save(UserName);
	    }

    }

}

