using System; 
using System.Text; 
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration; 
using System.Xml; 
using System.Xml.Serialization;
using SubSonic; 
using SubSonic.Utilities;

namespace MockSubSonic.DAL
{
    /// <summary>
    /// Controller class for UserChannelSubscription
    /// </summary>
    [System.ComponentModel.DataObject]
    public partial class UserChannelSubscriptionController
    {
        // Preload our schema..
        UserChannelSubscription thisSchemaLoad = new UserChannelSubscription();
        private string userName = string.Empty;
        protected string UserName
        {
            get
            {
				if (userName.Length == 0) 
				{
    				if (System.Web.HttpContext.Current != null)
    				{
						userName=System.Web.HttpContext.Current.User.Identity.Name;
					}

					else
					{
						userName=System.Threading.Thread.CurrentPrincipal.Identity.Name;
					}

				}

				return userName;
            }

        }

        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public UserChannelSubscriptionCollection FetchAll()
        {
            UserChannelSubscriptionCollection coll = new UserChannelSubscriptionCollection();
            Query qry = new Query(UserChannelSubscription.Schema);
            coll.LoadAndCloseReader(qry.ExecuteReader());
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Select, false)]
        public UserChannelSubscriptionCollection FetchByID(object Id)
        {
            UserChannelSubscriptionCollection coll = new UserChannelSubscriptionCollection().Where("id", Id).Load();
            return coll;
        }

		
		[DataObjectMethod(DataObjectMethodType.Select, false)]
        public UserChannelSubscriptionCollection FetchByQuery(Query qry)
        {
            UserChannelSubscriptionCollection coll = new UserChannelSubscriptionCollection();
            coll.LoadAndCloseReader(qry.ExecuteReader()); 
            return coll;
        }

        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public bool Delete(object Id)
        {
            return (UserChannelSubscription.Delete(Id) == 1);
        }

        [DataObjectMethod(DataObjectMethodType.Delete, false)]
        public bool Destroy(object Id)
        {
            return (UserChannelSubscription.Destroy(Id) == 1);
        }

        
        
    	
	    /// <summary>
	    /// Inserts a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Insert, true)]
	    public void Insert(int UserId,int ChannelId)
	    {
		    UserChannelSubscription item = new UserChannelSubscription();
		    
            item.UserId = UserId;
            
            item.ChannelId = ChannelId;
            
	    
		    item.Save(UserName);
	    }

    	
	    /// <summary>
	    /// Updates a record, can be used with the Object Data Source
	    /// </summary>
        [DataObjectMethod(DataObjectMethodType.Update, true)]
	    public void Update(int Id,int UserId,int ChannelId)
	    {
		    UserChannelSubscription item = new UserChannelSubscription();
		    
				item.Id = Id;
				
				item.UserId = UserId;
				
				item.ChannelId = ChannelId;
				
		    item.MarkOld();
		    item.Save(UserName);
	    }

    }

}

